zoukankan      html  css  js  c++  java
  • HDU 1969 Pie 【二分】

    Problem Description
    My birthday is coming up and traditionally I'm serving pie. Not just one pie, no, I have a number N of them, of various tastes and of various sizes. F of my friends are coming to my party and each of them gets a piece of pie. This should be one piece of one pie, not several small pieces since that looks messy. This piece can be one whole pie though.

    My friends are very annoying and if one of them gets a bigger piece than the others, they start complaining. Therefore all of them should get equally sized (but not necessarily equally shaped) pieces, even if this leads to some pie getting spoiled (which is better than spoiling the party). Of course, I want a piece of pie for myself too, and that piece should also be of the same size.

    What is the largest possible piece size all of us can get? All the pies are cylindrical in shape and they all have the same height 1, but the radii of the pies can be different.
     
    Input
    One line with a positive integer: the number of test cases. Then for each test case:
    ---One line with two integers N and F with 1 <= N, F <= 10 000: the number of pies and the number of friends.
    ---One line with N integers ri with 1 <= ri <= 10 000: the radii of the pies.
     
    Output
    For each test case, output one line with the largest possible volume V such that me and my friends can all get a pie piece of size V. The answer should be given as a floating point number with an absolute error of at most 10^(-3).
     
    Sample Input
    3
    3 3
    4 3 3
    1 24
    5
    10 5
    1 4 2 3 4 5 6 5 4 2
     
    Sample Output
    25.1327
    3.1416
    50.2655
     
    题目大意:一些人分馅饼,每个人分一块,或者多个人分一块,但是一个人不能分多块,求出每个人做多分的大小
    思路:二分实现,上边界是最大半径的平方
    代码如下:
    View Code
    #include<stdio.h>
    #include<string.h>
    #include<iostream>
    #include<algorithm>
    using namespace std; 
    #define pi 3.14159265358979  //pi=acos(-1.0)更精确
    #define N 10005 
    int a[N]; 
    double s[N]; 
    int main()
    {
        int i, j, n, m, T, r;
        scanf("%d", &T);
        while(T--)
        {
            scanf("%d%d", &n, &m);
            m++; 
            for(i=0; i<n; i++)
                scanf("%d", &a[i]);
            sort(a, a+n); 
            for(i=0; i<n; i++)
                s[i]=1.0*a[i]*a[i]; 
            double left=0, right=s[n-1], mid;
            while(right-left>1e-6)
            {
                int num=0;
                mid=(left+right)/2; 
                for(i=0; i<n; i++)
                {
                    if(s[i]>mid)
                        num+=(int)(s[i]/mid); 
                }
                if(num<m)
                    right=mid;
                else
                    left=mid;
            } 
            double area=pi*right;
            printf("%.4lf\n", area);
        }
    }             
  • 相关阅读:
    CSRF小结
    代码注入小结
    文件上传漏洞小结
    解决Burpsuite_pro_v1.6破解版https证书导入问题
    Java HTTP 组件库选型看这篇就够了
    趣图:我正在演示一个功能,但没有达到预期效果
    阅读源码的利器——Intellij-IDEA-Replace-in-Path-使用技巧
    分享一些好用的 Chrome 插件!
    趣图:程序员发量的变化过程
    Spring循环依赖的三种方式
  • 原文地址:https://www.cnblogs.com/Hilda/p/2635928.html
Copyright © 2011-2022 走看看